#include <iostream>
#include <vector>
#include <algorithm>

//Ovde dobijamo vec unapred sortiran niz, pa mozemo da saljemo const referencu bez ikakve opasnosti
bool binarna_pretraga(const std::vector<int> &niz, int x)
{
    // Leva granica je prvi indeks u nizu
    int l = 0;
    // Desna granica je poslednji indeks u nizu
    int d = niz.size() - 1;
    // Promenljiva u koju cemo smestati sredisnji indeks
    int s;

    // Dok god nam levi kraj ne preskoci desni
    while (l <= d) {
        // Delimo trenutni interval, i uzimamo indeks njegove sredine
        s = (l + d) / 2;

        // Ako se na sredini intervala nalazi bas trazeni element vracamo true, indikator da element postoji u nizu
        if (niz[s] == x) {
            return true;
        }

        // Ako se desi da je element na sredini indeksa manji od x, to znaci da se x sigurno nalazi desno u nizu (niz je prethodno
        // sortiran), pa zato samo azuriramo levu granicu i na taj nacin idemo desno. Desna granica ostaje ista zasad
        if (niz[s] < x) {
            l = s + 1;
        }
        // Ako se desi da je element na sredini indeksa veci od x (vec smo videli da nije jednak i nije manji, pa mora da bude veci, 
        // otud samo else), to znaci da se x sigurno nalazi levo u nizu (niz je prethodno sortiran), pa zato samo azuriramo desnu 
        // granicu i na taj nacin idemo levo. Leva granica ostaje ista zasad
        else {
            d = s - 1;
        }
    }

    // Ako dodjemo do ovde, to znaci da su se leva i desna granica "srele" i "mimoisle" i da nema trazenog elementa u nizu (vec bismo 
    // vratili true da je postojao u nizu)
    return false;
}

int main ()
{
    std::vector<int> niz = {7,4,5,9,8,7,6,7};

    std::sort(niz.begin(), niz.end());

    int x = 4;

    std::cout << std::binary_search(niz.begin(), niz.end(), x) << "\n";

    std::cout << binarna_pretraga(niz, x) << "\n";

    return 0;
}