#include <iostream>
#include <cmath>
#include <iomanip>
#include <cstdio>

// Funkcija za izracunavanje faktorijela datog broja
// Bitno nam je da povratna vrednost funkcije bude double, jer cemo racunati verovatnocu
double faktorijel(int n)
{
    // 1! = 1, pa cemo krenuti petlju od 2
    double rezultat = 1.0;

    // Idemo kroz sve brojeve od 2 do n i mnozimo ih sa prethodnim rezultatom
    for (int i = 2; i <= n; i++) {
        rezultat *= i;
    }

    return rezultat;
}

int main ()
{
    int n = 6;

    // Pocetna verovatnoca je 1
    double verovatnoca = 1.0;

    // Sve ostale racunamo kao (-1)^i/i! prema formuli iz teksta zadatka
    for (int i = 1; i <= n; i++) {
        verovatnoca += pow(-1, i) / faktorijel(i);
    }

    std::cout << verovatnoca << "\n";


    // Drugo, mnogo bolje resenje
    // Mozemo da primetimo da je 4! = 4 * 3!. Mozemo to da iskoristimo ako vec znamo koliko je 3!
    // Dakle, ako vec znamo koliko je n! mozemo lako izracunati (n + 1)!, a nama bas redom trebaju faktorijeli, i onda nema potrebe 
    // za njihovim konstantnim racunanjem. Takodje, kako nam se izmedju elemenata sume menja znak, dovoljno je uvek pomnoziti prethodni
    // element sa -1/k, gde je k trenutna vrednost do koje smo stigli

    // Ponovo vazi da je (-1)^0/0! == 1, pa je to pocetna vrednost
    verovatnoca = 1.0;

    // To nam je ujedno i trenutni element
    double trenutni_element = 1.0;

    for (int k = 1; k <= n; k++) {
        // Izracunavamo novi trenutni element (objasnjenje gore)
        trenutni_element *= -1.0/k;

        // Azuriramo i verovatnocu
        verovatnoca += trenutni_element;
    }
    
    std::cout << std::setprecision(14) << verovatnoca << "\n";

    return 0;
}